#include<evive.h>

// Defines Tirg and Echo pins of the Ultrasonic Sensor
const int trig = 2;
const int echo = 3;
   

// Variables for the duration and the distance
long duration;
int distance;

Servo mServo; // Creates a servo object for controlling the servo motor

void setup() 
   {
        pinMode(trig, OUTPUT); // Sets the trigPin as an Output
        pinMode(echo, INPUT); // Sets the echoPin as an Input
        Serial.begin(9600);
       
        mServo.attach(44); // Defines on which pin is the servo motor attached

         tft_init(INITR_GREENTAB);
        tft.setRotation(1);
        tft.fillScreen(ST7735_BLACK);

       tft.setCursor(25,10);
       tft.setTextSize(2);
       tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
       tft.print("STEMpedia");

       tft.setCursor(25,50);
       tft.setTextSize(1.8);
       tft.setTextColor(ST7735_GREEN,ST7735_BLACK);
       tft.print("ULTRASONIC RADAR");

       tft.setTextColor(ST7735_GREEN,ST7735_BLACK);
       tft.setCursor(0,105);
       tft.setTextSize(1.8);
       tft.print("FOR MORE INFORMATION VISIT");
       tft.setCursor(30,115);
       tft.setTextColor(ST7735_WHITE,ST7735_BLACK);
       tft.print("thestempedia.com");

   }

void loop()
     {
      
       // rotates the servo motor from 0 to 180 degrees
       
      for(int i=0;i<=180;i++)
      {  
        
         delay(30);
         distance = calculateDistance();  // Calls a function for calculating the distance measured by the Ultrasonic sensor for each degree
         mServo.write(i);             
         Serial.print(i); // Sends the current degree into the Serial Port
         Serial.print(","); // Sends addition character right next to the previous value needed later in the Processing IDE for indexing
         Serial.print(distance); // Sends the distance value into the Serial Port
         Serial.print("."); // Sends addition character right next to the previous value needed later in the Processing IDE for indexing
      }
      
  // Repeats the previous lines from 180 to 0 degrees
  
  for(int i=180;i>0;i--)
      {  
       
        delay(30);
        distance = calculateDistance();
        mServo.write(i);
        Serial.print(i);
        Serial.print(",");
        Serial.print(distance);
        Serial.print(".");
     }
}

// Function for calculating the distance measured by the Ultrasonic sensor

int calculateDistance()
     { 
  
          digitalWrite(trig, LOW); 
          delayMicroseconds(2);
          // Sets the trigPin on HIGH state for 10 micro seconds
          digitalWrite(trig, HIGH); 
          delayMicroseconds(10);
          digitalWrite(trig, LOW);
          duration = pulseIn(echo, HIGH); // Reads the echoPin, returns the sound wave travel time in microseconds
          distance= duration*0.034/2;
          return distance;
     }
